#include "XBP.CH"
#include "APPEVENT.CH"
#include "GRA.CH"
#include "XBPDEV.CH"

PROCEDURE APPSYS
RETURN

PROCEDURE MAIN
LOCAL nEvent := 0, mp1 := 0, mp2 := 0, oXbp
LOCAL nRed := 0, nGreen := 0, nBlue := 0
LOCAL oDlg
LOCAL oSlideRed
LOCAL oSlideGreen
LOCAL oSlideBlue
LOCAL oStatic
LOCAL oVert1,oVert2
LOCAL bCallback

   oDlg       := XbpDialog():new(AppDesktop() ,, {0,0}, {800,600} )
   oDlg:title := "native Slider Demo"
   oDlg:Icon  := 1
   oDlg:tasklist  := .T.
   oDlg:MaxButton := .F.
   oDlg:clipChildren := .T.
   oDlg:DrawingArea:clipChildren := .T.
   oDlg:create()

   // show Color
   //
   oStatic := XbpStatic():new(oDlg:DrawingArea,,{100,400},{400,140})
   oStatic:create()


   // vertical
   //
   oVert1 := DXE_Slider():New(oDlg:DrawingArea,,{550,100},{40,400})
   oVert1:Orientation := XBPPRN_ORIENT_PORTRAIT
   oVert1:Range := {0,255}
   oVert1:nBuddySpace  := 40
   oVert1:Drawmode     := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oVert1:ColorCHANNEL := GRA_CLR_YELLOW
   oVert1:ColorTHUMB   := GRA_CLR_CYAN
   oVert1:ColorSCOPE   := GRA_CLR_CYAN

   oVert1:Create()
   //
   oVert1:SetFrequency(20)
   oVert1:oBudTopLeft    :SetCaption("   Min")
   oVert1:oBudBottomRight:SetCaption("   Max")


   // vertical
   //
   oVert2 := DXE_Slider():New(oDlg:DrawingArea,,{610,100},{40,400})
   oVert2:Orientation := XBPPRN_ORIENT_PORTRAIT
*  oVert2:Range := {0,255}
   oVert2:Range := {-255,0}      // start on negative value
*  oVert2:Reversed     := .T.    // only Flag ?
*  oVert2:DownIsLeft   := .F.    // hm ... how does it work ?
   oVert2:nBuddySpace  := 40
   oVert2:Drawmode     := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oVert2:ColorCHANNEL := XBPSYSCLR_3DFACE
   oVert2:ColorTHUMB   := GRA_CLR_CYAN
   oVert2:ColorSCOPE   := XBPSYSCLR_ENTRYFIELD
   oVert2:Create()
   //
   oVert2:SetFrequency(20)
   // change Min/Max
   oVert2:oBudTopLeft    :SetCaption("   Max")
   oVert2:oBudBottomRight:SetCaption("   Min")


   // Red
   //
   oSlideRed   := DXE_Slider():New(oDlg:DrawingArea,,{100,100},{400,40})
   oSlideRed:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideRed:Range := {0,255}
   oSlideRed:Drawmode    := XBP_DRAW_OWNERADVANCED
   // need XBP_DRAW_OWNERADVANCED
   oSlideRed:ColorCHANNEL := GRA_CLR_RED
   oSlideRed:ColorSCOPE   := GRA_CLR_GREEN
   oSlideRed:ColorTHUMB   := GRA_CLR_BLUE
   oSlideRed:Create()
   //
   bCallback := {|mp1, mp2, oXbp| nRed   := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideRed:Track   := bCallback

   // Green
   //
   oSlideGreen := DXE_Slider():New(oDlg:DrawingArea,,{100,200},{400,40})
   oSlideGreen:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideGreen:Range := {0,255}
   oSlideGreen:nBuddySpace := 40
   oSlideGreen:Create()
   //
   oSlideGreen:oBudTopLeft    :SetCaption("Min")
   oSlideGreen:oBudBottomRight:SetCaption("Max")
   //
   bCallback := {|mp1, mp2, oXbp| nGreen := mp1 ,;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideGreen:Track := bCallback

   // Blue
   //
   oSlideBlue  := DXE_Slider():New(oDlg:DrawingArea,,{100,300},{400,40})
   oSlideBlue:Orientation := XBPPRN_ORIENT_LANDSCAPE
   oSlideBlue:Range := {0,255}
   oSlideBlue:Create()
   bCallback := {|mp1, mp2, oXbp| nBlue  := mp1 , ;
                         ShowRGB( nRed, nGreen, nBlue ,oStatic) }
   oSlideBlue:Track  := bCallback


   CenterControl(oDlg)

   // mark Scope with Cursor Check when move
   //
   oVert1      :SetScope({050,200})
   oVert1      :SetScope({075,175})

   oSlideRed  :SetScope({050,185})
   oSlideGreen:SetScope({100,185})
   oSlideBlue :SetScope({101,250})

   // default Ticks ( Marker ) 1
   //
   oSlideRed  :SetFrequency(20)
   oSlideGreen:SetFrequency(10)
   oSlideBlue :SetFrequency(5)

   // Set-/Get-Data as usual
   //
   oSlideRed  :SetData(128)
   oSlideGreen:SetData(128)
   oSlideBlue :SetData(128)

   ShowRGB( nRed, nGreen, nBlue ,oStatic)
   SetAppFocus(oSlideRed)

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )

      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE ShowRGB( nRed, nGreen, nBlue ,oStatic)
LOCAL oPS   := oStatic:lockPS() // presentation space
LOCAL aAttr := Array(GRA_AA_COUNT)        // area attributes
LOCAL aAStr := Array(GRA_AS_COUNT)        // string attributes
LOCAL nMax  := oPS:maxColorIndex()        // maximum colors
LOCAL aOldAttr
LOCAL aSize := oStatic:CurrentSize()

   // Set RGB color passed and draw box to
   // visualize it
   oPS:setColorIndex( nMax, {nRed,nGreen,nBlue} )

   aAttr[ GRA_AA_COLOR  ] := nMax
   aOldAttr := oPS:setAttrArea( aAttr )
   GraBox( oPS, {0,0}, aSize, GRA_FILL )
   oPS:setAttrArea( aOldAttr )

   aAStr[ GRA_AL_COLOR ] := XBPSYSCLR_WINDOWTEXT
   GraSetAttrString( oPS, aAStr )
   GraStringAt( oPS, {100, aSize[2]/2}, "R/G/B" + str(nRed)+str(nGreen)+str(nBlue) )

   oStatic:unlockPS()

RETURN

*
*
*